darcs

Safe Haskell | Safe-Infered

Darcs.Witnesses.WZipper

Synopsis

- data FZipper a where
  - FZipper :: RL a -> FL a -> FZipper a
- focus :: FZipper a -> Maybe (Sealed2 a)
- leftmost :: FZipper p -> Bool
- left :: FZipper p -> FZipper p
- rightmost :: FZipper p -> Bool
- right :: FZipper p -> FZipper p
- jokers :: FZipper a -> FlippedSeal (FL a)
- clowns :: FZipper a -> Sealed (RL a)
- flToZipper :: FL a -> FZipper a
- lengthFZ :: FZipper a -> Int
- nullFZ :: FZipper a -> Bool
- toEnd :: FZipper p -> FZipper p
- toStart :: FZipper p -> FZipper p

# Documentation

data FZipper a where

Constructors

FZipper :: RL a -> FL a -> FZipper a |

focus :: FZipper a -> Maybe (Sealed2 a)

leftmost :: FZipper p -> Bool

left :: FZipper p -> FZipper p

rightmost :: FZipper p -> Bool

right :: FZipper p -> FZipper p

jokers :: FZipper a -> FlippedSeal (FL a)

See `clowns`

clowns :: FZipper a -> Sealed (RL a)

"Clowns to the left of me, jokers to the right. Here I am, stuck in the middle of you" http://en.wikipedia.org/wiki/Stuck_in_the_Middle

flToZipper :: FL a -> FZipper a

lengthFZ :: FZipper a -> Int

nullFZ :: FZipper a -> Bool

toEnd :: FZipper p -> FZipper p

toStart :: FZipper p -> FZipper p